program OsmKostek;
{$APPTYPE CONSOLE}
uses
  SysUtils;

const
  MAX_CNT = 10000;
  N = 8;

type
  TPos = record
    X,Y : Byte;
  end;
  TState = array[1..N] of Byte;

function CountConflicts(St : TState) : Integer;
var I,J : Byte;
begin
  Result:=0;
  for I:=1 to N do begin
    for J:=1 to N do begin
      if I<>J then begin
        if (St[I]=St[J]) or ((I-St[I])=(J-St[J])) or ((I+St[I])=(J+St[J])) then begin
          Inc(Result);
        end;
      end;
    end;
  end;
end;

{procedure Exchange(var St : TState; I,J : Integer);
var Pom : Integer;
begin
  Pom:=St[I];
  St[I]:=St[J];
  St[J]:=Pom;
end;

function OsmDam(var St : TState; Pos : Integer; var Cnt : Integer) : Boolean;
var Min, Move, Pom : Integer;
    I : Integer;
begin
  Min:=CountConflicts(St);
  if Min>0 then begin
    Move:=Pos;
    for I:=1 to N do begin
      if I<>Pos then begin
        Exchange(St,Pos,I);
        Pom:=CountConflicts(St);
        if (Pom<Min) or ((Pom=Min) and (Random(2)=1)) then begin
          Move:=I;
          Min:=Pom;
        end;
        Exchange(St,Pos,I);
      end;
    end;
    if Move<>Pos then begin
      Exchange(St,Pos,Move);
      Inc(Cnt);
      Result:=OsmDam(St,Move,Cnt);
    end else Result:=False;
  end else Result:=True;
end;}

{function OsmDam(var St : TState; var Cnt : Integer) : Boolean;
var Min, Pos, New, Pom : Integer;
    I,J : Integer;
begin
  Min:=CountConflicts(St);
  Pos:=0;
  New:=0;
  if Min>0 then begin
    for I:=1 to N do begin
      for J:=1 to N-1 do begin
        St[I]:=((St[I]+J) mod N)+1;
        Pom:=CountConflicts(St);
        if (Pom<Min) or ((Pom=Min) and (Random(2)=1)) then begin
          Pos:=I;
          New:=St[I];
          Min:=Pom;
        end;
        St[I]:=((N+St[I]-J) mod N)+1;
      end;
    end;
    if Pos>0 then begin
      St[Pos]:=New;
      Inc(Cnt);
      Result:=OsmDam(St,Cnt);
    end else Result:=False;
  end else Result:=True;
end;}

function OsmDam(var St : TState; var Cnt : Integer) : Boolean;
var Min, Pos, New, Pom : Integer;
    I,J : Integer;
begin
  Result:=False;
  Min:=CountConflicts(St);
  Pos:=0;
  New:=0;
  if Min>0 then begin
    for I:=1 to N do begin
      for J:=1 to N-1 do begin
        St[I]:=((St[I]+J) mod N)+1;
        Pom:=CountConflicts(St);
        if (Pom<Min) or ((Pom=Min) and (Random(2)=1)) then begin
          Pos:=I;
          New:=St[I];
          Min:=Pom;
        end;
        St[I]:=((N+St[I]-J) mod N)+1;
      end;
    end;
    if Pos>0 then begin
      St[Pos]:=New;
      Inc(Cnt);
      Result:=True;
    end;
  end;
end;

procedure CopyState(var StFrom, StTo : TState);
var I : Byte;
begin
  for I:=1 to N do StTo[I]:=StFrom[I];
end;

procedure WriteState(var St : TState);
var I,J : Byte;
begin
  WriteLn('  |A B C D E F G H');
  WriteLn('-------------------');
  for I:=1 to N do begin
    Write(' '+IntToStr(I)+'|');
    for J:=1 to N do begin
      if St[J]=I then Write('<>') else Write('  ');
    end;
    WriteLn('');
    // WriteLn(Format(' %d|%*s',[I,2*St[I],'<>']));
  end;
  WriteLn('-------------------');
end;


var State : TState;
    PocState : TState;
    BigCnt,Cnt : Integer;
    I,J : Integer;
begin
  WriteLn('Osm dam :');
  State[1]:=2;
  State[2]:=5;
  State[3]:=7;
  State[4]:=4;
  State[5]:=1;
  State[6]:=3;
  State[7]:=6;
  State[8]:=8;
  //for I:=1 to N do State[I]:=((2*I-1) mod 8);
  //for I:=1 to N do State[I]:=I;
  //for I:=1 to N do State[I]:=1;
  Randomize;
  CopyState(State,PocState);
  WriteState(State);
  Cnt:=0;
  BigCnt:=0;
  for J:=1 to 1000 do begin
    // J:=Random(N)+1;
    // WriteLn('INIT ('+IntToStr(J)+')');
    if not OsmDam(State,{J,}Cnt) then begin
      if CountConflicts(State)=0 then begin
        WriteState(State);
        BigCnt:=BigCnt+Cnt;
        WriteLn('OK '+IntToStr(BigCnt)+' ('+IntToStr(Cnt)+')');
        Break;
      end else begin
        WriteLn('NENALEZENO '+IntToStr(BigCnt)+' ('+IntToStr(Cnt)+')');
        State[1]:=2;
        State[2]:=5;
        State[3]:=7;
        State[4]:=4;
        State[5]:=1;
        State[6]:=3;
        State[7]:=6;
        State[8]:=8;
        //for I:=1 to N do State[I]:=((2*I-1) mod 8);
        //for I:=1 to N do State[I]:=I;
        //for I:=1 to N do State[I]:=1;
        BigCnt:=BigCnt+Cnt;
        Cnt:=0;
        // Break;
      end;
    end;
  end;
  ReadLn;
end.

